/**
	Trial of a C - Interface to the VGA 64 Driver from 	OBEX
	VGA64 6 Bits Per Pixel Engine

ORIGIN:
    Author: Kwabena W. Agyeman
    Updated: 11/17/2010
    Designed For: P8X32A
    Version: 1.0

    Copyright (c) 2010 Kwabena W. Agyeman
--------------------------------------------------
	Code from PUB PIXEngineStart(pinGroup) 
	is go to main
	
	very experimental, basicly works
	
*/

#include <stdlib.h>
#include <propeller.h>                   
////////////////////////////////////////////////////////////////////////
//  Mailbox
////////////////////////////////////////////////////////////////////////
static unsigned int directionState; 
static unsigned int videoState;
static unsigned int frequencyState;
static unsigned int * displayPtr;

static unsigned int *syncIndicatorAdress;
static unsigned int *displayIndicatorAdress;
////////////////////////////////////////////////////////////////////////
unsigned int DISPLAY_BUFFER[(160 * 120) / 4];
unsigned int sync_indi;
unsigned int display_indi;
////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////
unsigned int _rotl( unsigned int value, int shift) 
{
    if ((shift &= sizeof(value)*8 - 1) == 0)
      return value;
    return (value << shift) | (value >> (sizeof(value)*8 - shift));
}
////////////////////////////////////////////////////////////////////////
int start(unsigned int *ptr)  
{
    extern unsigned int binary_vga64_pix_dat_start[];
    return cognew(&binary_vga64_pix_dat_start, ptr);
}
////////////////////////////////////////////////////////////////////////
void usleep(int t)
{
    if(t < 10)  // very small t values will cause a hang
        return; // don't bother function delay is likely enough
    waitcnt((CLKFREQ/1000000)*t+CNT);
}
////////////////////////////////////////////////////////////////////////
void main (void)
{
    int tmp,i,x,y;
	
	// Preset the mailbox parameters

	directionState = 0xFF << 16;
	
	videoState = (0x300000FF | (2 << 9));

	tmp = (25175000 + 1600) / 4;
	frequencyState = 1 ;

	for(i = 0; i < 32; i++)
	{
		tmp = tmp << 1;
		frequencyState = _rotl(frequencyState,1);
		if(tmp >= _clkfreq)
		{
			tmp = tmp - _clkfreq;
			frequencyState += 1;
		}
		
	}
	
	displayPtr = DISPLAY_BUFFER;
	
	syncIndicatorAdress = &sync_indi;
	
	displayIndicatorAdress = &display_indi;
	
	// start the Driver
	
	start(&directionState);
	
    while(1)
	{
		for (y = 0; y < 120;y++)
		{
		  for (x = 0; x < 160;x++)
		  {
		    while((0x80 >> 5) & sync_indi);
			//DISPLAY_BUFFER[x + 160 * y] = 0xFF; // set a white pixel at (x,y)
			*(unsigned char *)(DISPLAY_BUFFER + x + 160 * y) = 0x30; // Lightgreen
		  }
		}
	}
}
////////////////////////////////////////////////////////////////////////


